#!/usr/bin/env python
# -*- coding : UTF-8 -*-

import os, sys, tempfile

def convert_file(arg, dirname, fnames):
    if dirname.count(".svn") == 0:
        print "converting %s files in %s" % (arg[0],dirname)
        for fic in fnames:
            if fic.endswith('.py'):
                data = open(fic).read()
                try:
                    unicode(data,arg[1])
                except:
                    try:
                        unicode(data,arg[0])
                    except:
                        # mauvais encoding de depart
                        print " ! %s : mauvais encoding (%s attendu)" % (fic, arg[0])
                    else:
                        # conversion
                        tmp_f = tempfile.mkstemp()[1]
                        print " * %s : %s --> %s" % (fic, arg[0], arg[1])
                        #os.system("iconv -f %s -t %s %s >%s" % (arg[0],arg[1],fic,tmp_f))
                        #os.system("mv -f %s %s" % (tmp_f,fic))
                else:
                    # fichier deja au bon format
                    print " - %s already encoded" % fic

if __name__ == '__main__':
    recursive = True
    try:
        topdir = sys.argv[1]
        assert os.path.isdir(topdir)
    except:
        sys.exit('usage : %s <directory>' % sys.argv[0])

    from_enc = 'ISO-8859-1'
    to_enc = 'UTF-8'
    if recursive:
        os.path.walk(topdir, convert_file, [from_enc, to_enc])
    else:
        files = []
        for fic in os.listdir(topdir):
            if os.path.isfile(fic):
                files.append(fic)
        convert_file([from_enc, to_enc], topdir, files)
